| ARX 1.0 The next-generation open source augmented reality toolkit.

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
ARVideoView Class Reference

ARVideoView draws the output of an ARVideoSource to a rendering context, usually for the purposes of video see-through augmented reality. More...

`#include <ARVideoView.h>`

## Classes
struct | Size

## Public Types
enum class | HorizontalAlignment { H_ALIGN_LEFT , H_ALIGN_CENTRE , H_ALIGN_RIGHT }
enum class | VerticalAlignment { V_ALIGN_TOP , V_ALIGN_CENTRE , V_ALIGN_BOTTOM }
enum class | ScalingMode { SCALE_MODE_STRETCH , SCALE_MODE_FIT , SCALE_MODE_FILL , SCALE_MODE_1_TO_1 }

## Public Member Functions
| ARVideoView ()
bool | initWithVideoSource (const ARVideoSource &vs, const int contextWidth, const int contextHeight)
void | getViewport (int32_t viewport[4]) const
void | draw (ARVideoSource *vs)
void | drawDebugImage (const uint8_t *image, int pyramidLevel)
| ~ARVideoView ()
HorizontalAlignment | horizontalAlignment () const
void | setHorizontalAlignment (const HorizontalAlignment hAlign)
VerticalAlignment | verticalAlignment () const
| ‍Defaults to H_ALIGN_CENTRE.
void | setVerticalAlignment (const VerticalAlignment vAlign)
ScalingMode | scalingMode () const
| ‍Defaults to V_ALIGN_CENTRE.
void | setScalingMode (const ScalingMode scalingMode)
bool | distortionCompensation () const
| ‍Defaults to SCALE_MODE_FIT.
void | setDistortionCompensation (const bool distortionCompensation)
bool | rotate90 () const
| ‍Defaults to true.
void | setRotate90 (const bool rotate90)
bool | flipH () const
| ‍Defaults to false.
void | setFlipH (const bool flipH)
bool | flipV () const
| ‍Defaults to false.
void | setFlipV (const bool flipV)
Size | contextSize () const
| ‍Defaults to false.
void | setContextSize (const Size size)

## Detailed Description

ARVideoView draws the output of an ARVideoSource to a rendering context, usually for the purposes of video see-through augmented reality.

A rendering context supported by libARG must be active when calling any non-const function in this class. For example, on platforms supporting OpenGL, a valid OpenGL context must be initialised and active at the time of the call. For most OpenGL implementations, such a call can only be made from a rendering thread.

## Member Enumeration Documentation

## ◆ HorizontalAlignment

enum class ARVideoView::HorizontalAlignment
| strong

Enumerator
H_ALIGN_LEFT |
H_ALIGN_CENTRE |
H_ALIGN_RIGHT |

## ◆ ScalingMode

enum class ARVideoView::ScalingMode
| strong

Enumerator
SCALE_MODE_STRETCH |
SCALE_MODE_FIT |
SCALE_MODE_FILL |
SCALE_MODE_1_TO_1 |

## ◆ VerticalAlignment

enum class ARVideoView::VerticalAlignment
| strong

Enumerator
V_ALIGN_TOP |
V_ALIGN_CENTRE |
V_ALIGN_BOTTOM |

## Constructor & Destructor Documentation

## ◆ ARVideoView()

ARVideoView::ARVideoView | ( |  | ) |

## ◆ ~ARVideoView()

ARVideoView::~ARVideoView | ( |  | ) |

Here is the call graph for this function:

## Member Function Documentation

## ◆ contextSize()

ARVideoView::Size ARVideoView::contextSize | ( |  | ) | const

> ‍Defaults to false.

## ◆ distortionCompensation()

bool ARVideoView::distortionCompensation | ( |  | ) | const

> ‍Defaults to SCALE_MODE_FIT.

## ◆ draw()

void ARVideoView::draw | ( | ARVideoSource * | vs | ) |

Here is the call graph for this function:

## ◆ drawDebugImage()

void ARVideoView::drawDebugImage | ( | const uint8_t * | image,
|  | int | pyramidLevel
| ) |  |

Here is the call graph for this function:

## ◆ flipH()

bool ARVideoView::flipH | ( |  | ) | const

> ‍Defaults to false.

## ◆ flipV()

bool ARVideoView::flipV | ( |  | ) | const

> ‍Defaults to false.

## ◆ getViewport()

void ARVideoView::getViewport | ( | int32_t | viewport[4] | ) | const

## ◆ horizontalAlignment()

ARVideoView::HorizontalAlignment ARVideoView::horizontalAlignment | ( |  | ) | const

## ◆ initWithVideoSource()

bool ARVideoView::initWithVideoSource | ( | const ARVideoSource & | vs,
|  | const int | contextWidth,
|  | const int | contextHeight
| ) |  |

Here is the call graph for this function:

## ◆ rotate90()

bool ARVideoView::rotate90 | ( |  | ) | const

> ‍Defaults to true.

## ◆ scalingMode()

ARVideoView::ScalingMode ARVideoView::scalingMode | ( |  | ) | const

> ‍Defaults to V_ALIGN_CENTRE.

## ◆ setContextSize()

void ARVideoView::setContextSize | ( | const Size | size | ) |

## ◆ setDistortionCompensation()

void ARVideoView::setDistortionCompensation | ( | const bool | distortionCompensation | ) |

Here is the call graph for this function:

## ◆ setFlipH()

void ARVideoView::setFlipH | ( | const bool | flipH | ) |

Here is the call graph for this function:

## ◆ setFlipV()

void ARVideoView::setFlipV | ( | const bool | flipV | ) |

Here is the call graph for this function:

## ◆ setHorizontalAlignment()

void ARVideoView::setHorizontalAlignment | ( | const HorizontalAlignment | hAlign | ) |

## ◆ setRotate90()

void ARVideoView::setRotate90 | ( | const bool | rotate90 | ) |

Here is the call graph for this function:

## ◆ setScalingMode()

void ARVideoView::setScalingMode | ( | const ScalingMode | scalingMode | ) |

Here is the call graph for this function:

## ◆ setVerticalAlignment()

void ARVideoView::setVerticalAlignment | ( | const VerticalAlignment | vAlign | ) |

## ◆ verticalAlignment()

ARVideoView::VerticalAlignment ARVideoView::verticalAlignment | ( |  | ) | const

> ‍Defaults to H_ALIGN_CENTRE.

The documentation for this class was generated from the following files:

- Source/ARX/include/ARX/ARVideoView.h
- Source/ARX/ARVideoView.cpp